/*
 * Copyright (c) 2007-2008 University of Washington
 *
 * All rights reserved. For information, contact the Adeona research
 * team at adeona@cs.washington.edu
 *
 * See the file License.txt included in this distribution for details.
 *
 */
#ifndef _OPTIONS_H_
#define _OPTIONS_H_

#define MIN_SLEEPTIME        300   // 5 minutes
#define MAX_STROPTION_LEN    1024

#define RES_OPTIONS   (0x01)
#define RES_GATEWAYS  (0x01 << 1)
#define RES_LANDMARKS (0x01 << 2)
#define RES_WEBCAM    (0x01 << 3)
#define RES_ALL ( RES_OPTIONS + RES_GATEWAYS + RES_LANDMARKS + RES_WEBCAM )

#define STROPT_ISLOADED( stropt ) ( stropt[0] != 0x00 ) 

typedef struct _options
{
    int have_console; // option set by app/*.c messages should go to stdout

    char  log_filenamebase[MAX_STROPTION_LEN];
    //char  log_filename[MAX_STROPTION_LEN];
    int   ctxt_queue_size;
    float sched_lambda;
    int   server_port;
    char  server_name[MAX_STROPTION_LEN];
    int   num_dhtkeys_totry;
    char  gateways_filename[MAX_STROPTION_LEN];
    int   use_traceroutes;
    //char  landmarks_filename[MAX_STROPTION_LEN];
    int   max_sleeptime;
    int   use_webcamimg;   
    char  webcamprog_path[MAX_STROPTION_LEN];
    char  gwupdate_url[MAX_STROPTION_LEN];
    int   use_gwupdate;   
    char  extip_url[MAX_STROPTION_LEN];
} options_t;

extern options_t opts;

void load_default_options( void );

int setup_logdir( char* logdir, char* logname );
int setup_resources( char* resourcedir, int flags );

int seek_past_options( FILE* optFile );
int parse_options_filename( char* optionsFileName );
int parse_options_file( FILE* optFile );

int write_options_file( FILE* file , int fRetrievalOpts );

#endif // _OPTIONS_H_

