/*
 * Copyright (c) 2007-2008 University of Washington
 * 
 * All rights reserved. For information, contact the Adeona research
 * team at adeona@cs.washington.edu
 *
 * See the file License.txt included in this distribution for details.
 *
 */
#ifndef _UTIL_H_
#define _UTIL_H_

#include "common.h"
#include <time.h>

int hex2bin( uchar* hex IN, int hlen IN, uchar* bin OUT, int blen IN );
int bin2hex( uchar* hex OUT, int hlen IN, uchar* bin IN, int blen IN );

int fprintln_bin2hex( FILE* file IN, uchar* bin IN, int len IN );
int fprintln_data2hex( FILE* file IN, void* data IN, int len IN );

int freadln_hex2bin( FILE* file IN, uchar* bin IN, int len IN );
int freadln_hex2data( FILE* file IN, void* data IN, int len IN );
#define println_bin2hex( bin, len ) fprintln_bin2hex( stdout, bin, len ) 

void datacpy( void* dst IN, void* src IN, int len IN );

int get_random_bytes( uchar* buf OUT, int len IN );
unsigned int get_random_uint( unsigned int max );

char* time2string( time_t time IN, int utc IN );
char* time2fstring( time_t time IN, int utc IN );
time_t string2time( char* timestr IN );

int exec_command( char* cmd IN, char* buffer OUT, int blen IN );

int count_lines_in_file( FILE* file IN );

char* concatstr( char* str1 IN, char* str2 IN );

int pwdprompt_loop( char* pwdbuf OUT, int* plen INOUT, int verify IN );

uint flipmsb( uint x );

int ismsbset( uint x );

int allowed_chars_only( const char* string IN, int slen, const char* allowed IN );


#endif // _UTIL_H_

