/*
 * Copyright (c) 2007-2008 University of Washington
 * 
 * All rights reserved. For information, contact the Adeona research
 * team at adeona@cs.washington.edu
 *
 * See the file License.txt included in this distribution for details.
 *
 */
#ifndef _AUTH_ENCRYPT_H_
#define _AUTH_ENCRYPT_H_

#include "common.h"
#include "encrypt.h"
#include "hmac.h"

int encrypt_then_mac( 
        enckey_t ekey IN, 
        hmackey_t hkey IN,
        uchar* pt IN, 
        int plen, 
        uchar* ct OUT, 
        int clen IN );

// Always allocs, caller must dealloc
int encrypt_then_mac_alloc( 
        enckey_t ekey IN, 
        hmackey_t hkey IN,
        uchar* pt IN, 
        int plen, 
        uchar** ct OUT, 
        int* clen OUT );


int verify_then_decrypt(
        enckey_t ekey IN, 
        hmackey_t hkey IN,
        uchar* ct IN,
        int clen IN,
        uchar* pt OUT,
        int plen IN );

// Always allocs, caller must dealloc
int verify_then_decrypt_alloc(
        enckey_t ekey IN, 
        hmackey_t hkey IN,
        uchar* ct IN,
        int clen IN,
        uchar** pt OUT,
        int* plen OUT );

#endif // _AUTH_ENCRYPT_H_
