/*
 * Copyright (c) 2007-2008 University of Washington
 * 
 * All rights reserved. For information, contact the Adeona research
 * team at adeona@cs.washington.edu
 *
 * See the file License.txt included in this distribution for details.
 *
 */
#ifndef _HMAC_H_
#define _HMAC_H_

#include "common.h"
#include "prg.h"

/* 
 * We use sha-1 because MacOSX seem to have openssl with no SHA-2
 * support yet.
 *
 */
#define HMACSHA1_LEN 20
#define HMAC_LEN HMACSHA1_LEN

typedef prgblock_t hmackey_t; // 128-bit key
typedef uchar      hmactag_t[HMAC_LEN]; 

int hmac_compute( hmackey_t key IN, uchar* data IN, int dlen IN, uchar* mac OUT );
int hmac_verify( hmackey_t key IN, uchar* data IN, int dlen IN, uchar* mac IN );

int hmacsha1_compute( uchar* key IN, int klen IN, uchar* data IN, int dlen IN, uchar* mac OUT );
int hmacsha1_verify( uchar* key IN, int klen IN, uchar* data IN, int dlen IN, uchar* mac IN );

#endif // _HMAC_H_

