/*
 * Copyright (c) 2007-2008 University of Washington
 * 
 * All rights reserved. For information, contact the Adeona research
 * team at adeona@cs.washington.edu
 *
 * See the file License.txt included in this distribution for details.
 *
 */
#ifndef _PRG_H_
#define _PRG_H_

#include "common.h"

/* Tom says: I don't feel like typing in 2^128 - 1, so I'll just use
 * something reasonable like .... INT_MAX. This will be more than
 * enough for us. It will probably make that loop faster if we replace
 * counter with an int, too, inside cr_prg_generate, but not a big
 * deal.
 */
#define PRG_BLOCKCIPHER EVP_aes_128_ecb() 
#define PRG_MAX_COUNTER  INT_MAX
#define PRG_BLOCKSIZE 16
#define PRG_KEYSIZE PRG_BLOCKSIZE
#define PRG_HEX_KEYSIZE PRG_KEYSIZE*2

typedef uchar prgblock_t[PRG_BLOCKSIZE];
typedef prgblock_t prgkey_t; 

int prg_generate( prgkey_t key IN, int rangeLow IN, int rangeHigh IN, uchar* outbuf OUT );

#endif // _PRG_H_

