; Script generated by the HM NIS Edit Script Wizard.

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "Adeona"
!define PRODUCT_VERSION "v0.2"
!define PRODUCT_PUBLISHER "University of Washington"
!define PRODUCT_WEB_SITE "http://adeona.cs.washington.edu"

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "adeona_globeonly_trans.ico"
!define MUI_UNICON "adeona_globeonly_trans.ico"
!define MUI_WELCOMEFINISHPAGE_BITMAP "adeona_inst_globe.bmp"
!define MUI_WELCOMEFINISHPAGE_BITMAP_NOSTRETCH
!define MUI_UNWELCOMEFINISHPAGE_BITMAP "adeona_inst_globe.bmp"
!define MUI_UNWELCOMEFINISHPAGE_BITMAP_NOSTRETCH
!define MUI_HEADERIMAGE
!define MUI_HEADERIMAGE_BITMAP "adeona_inst_globe_small.bmp"
!define MUI_HEADERIMAGE_BITMAP_NOSTRETCH
!define MUI_HEADERIMAGE_RIGHT

; Welcome page
!insertmacro MUI_PAGE_WELCOME
; License page
!insertmacro MUI_PAGE_LICENSE "packagefiles\License.txt"
; Directory page
!insertmacro MUI_PAGE_DIRECTORY
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "AdeonaSetup.exe"
InstallDir "$PROGRAMFILES\Adeona"
ShowInstDetails show
ShowUnInstDetails show

Section "MainSection" SEC01

  CreateDirectory "$INSTDIR\resources"
  CreateDirectory "$INSTDIR\logs"
  SetOutPath "$INSTDIR\resources"
  SetOverwrite ifnewer
;  File "packagefiles\resources\options.adeona"
  File "packagefiles\resources\landmarks.adeona"
  File "packagefiles\resources\gateways.adeona"
  SetOutPath "$INSTDIR"
  SetOverwrite ifnewer
  File "packagefiles\Conclusion.txt"
  File "packagefiles\InitAdeona.bat"
  File "packagefiles\StartAdeona.bat"
  File "packagefiles\StopAdeona.bat"
  File "packagefiles\adeona-retrieve.bat"
  File "packagefiles\AdeonaRecovery.exe"
  File "packagefiles\adeona-client.exe"
  File "packagefiles\adeona-retrieve.exe"
  File "packagefiles\adeona-retrieve.bat"
  File "packagefiles\adeona-init.exe"
  File "packagefiles\cygcrypto-0.9.8.dll"
  File "packagefiles\cygrunsrv.exe"
  File "packagefiles\cygwin1.dll" 
	
  ExecWait '"$INSTDIR\InitAdeona.bat" "$INSTDIR"'
  
  CopyFiles "$INSTDIR\adeona-retrievecredentials.ost" "$DESKTOP\"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\Uninstall.exe"
SectionEnd


Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "Adeona was successfully removed from your computer."
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove Adeona and all of its components?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  SetOutPath "$INSTDIR"  ; Something very strange with working directory for StopAdeona.bat
  ExecWait '"$INSTDIR\StopAdeona.bat"'

  Delete "$INSTDIR\resources\*"
  RMDir "$INSTDIR\resources"
  Delete "$INSTDIR\logs\*"
  RMDir "$INSTDIR\logs"
  Delete "$INSTDIR\*"
  
  SetOutPath "C:\"
  RMDir "$INSTDIR" ; This fails for some reason

  SetAutoClose false
SectionEnd
