; Script generated by the HM NIS Edit Script Wizard.

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "Adeona"
!define PRODUCT_VERSION "v0.2.1"
!define PRODUCT_PUBLISHER "University of Washington"
!define PRODUCT_WEB_SITE "http://adeona.cs.washington.edu"

SetCompressor zlib

; MUI 1.67 compatible ------
!include "MUI.nsh"
!include nsDialogs.nsh
;!include LogicLib.nsh

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "adeona_globeonly_trans.ico"
!define MUI_UNICON "adeona_globeonly_trans.ico"
!define MUI_WELCOMEFINISHPAGE_BITMAP "adeona_inst_globe.bmp"
!define MUI_WELCOMEFINISHPAGE_BITMAP_NOSTRETCH
!define MUI_UNWELCOMEFINISHPAGE_BITMAP "adeona_inst_globe.bmp"
!define MUI_UNWELCOMEFINISHPAGE_BITMAP_NOSTRETCH
!define MUI_HEADERIMAGE
!define MUI_HEADERIMAGE_BITMAP "adeona_inst_globe_small.bmp"
!define MUI_HEADERIMAGE_BITMAP_NOSTRETCH
!define MUI_HEADERIMAGE_RIGHT
;!define MUI_FINISHPAGE_TITLE "Installation successful."
;!define MUI_FINISHPAGE_TEXT_LARGE
;!define MUI_FINISHPAGE_TEXT "IMPORTANT: Please don't forget to make a backup copy of your location-finding credentials,\r\n\r\n\
;                            \t adeona-retrievecredentials.ost\r\n\r\n\
;                            A copy has been created on your Desktop. You can simply e-mail it to yourself, put it in a USB Memory Stick or, \
;                            even write down the contents on a piece of paper since the contents have been protected by the password you gave \
;                            during the installation process.\r\n\r\n\
;                            NOTE: Adeona has pseudorandomly scheduled updates and there may not be any location information stored in OpenDHT \
;                            yet. Please wait about 30 minutes before trying to do a retrieval.\r\n\r\n\
;                            For questions, comments and suggestions, please send an e-mail to adeona@cs.washington.edu\r\n\r\n\
;                            Thank you for using Adeona!"
                            
; Welcome page
!insertmacro MUI_PAGE_WELCOME
; License page
!define MUI_LICENSEPAGE_CHECKBOX
!insertmacro MUI_PAGE_LICENSE "..\..\License.txt"
!define MUI_PAGE_CUSTOMFUNCTION_LEAVE myComponentLeave
!insertmacro MUI_PAGE_COMPONENTS
; Directory page
!insertmacro MUI_PAGE_DIRECTORY
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Password page
Page custom passwordPage passwordPageEnd
; Custom finish page
Page custom FinishPage

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"



; MUI end ------


Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "AdeonaSetup.exe"
InstallDir "$PROGRAMFILES\Adeona"
ShowInstDetails show
ShowUnInstDetails show
RequestExecutionLevel admin

Var passwordbox
Var password
Var Dialog
Var Label
Var passwordboxver
Var passwordver
Var clientflag


Section "-common installation stuff"

  CreateDirectory "$INSTDIR\resources"
  CreateDirectory "$INSTDIR\logs"
  SetOutPath "$INSTDIR\resources"
  SetOverwrite ifnewer
;  File "packagefiles\resources\options.adeona"
  File "..\..\resources\landmarks.adeona"
  File "..\..\resources\gateways.adeona"
  File "..\..\resources\options.adeona"
  SetOutPath "$INSTDIR"
  SetOverwrite ifnewer
  File "packagefiles\cygcrypto-0.9.8.dll"
  File "packagefiles\cygrunsrv.exe"
  File "packagefiles\cygwin1.dll"

; Create options file
;  FileOpen $0 "$INSTDIR\resources\options.adeona" w
;;  FileWrite $0 "LOG_FILENAME = $INSTDIR\logs\adeona.log$\n"
;  FileWrite $0 "CTXT_QUEUE_SIZE = 1$\n"
;  FileWrite $0 "SERVER_NAME = opendht.nyuld.net$\n"
;  FileWrite $0 "SERVER_PORT = 5852$\n"
;  FileWrite $0 "SCHED_LAMBDA = 0.001$\n"
;  FileWrite $0 "NUM_DHTKEYS_TOTRY = 2$\n"
;  FileWrite $0 "USE_TRACEROUTES = 1$\n"
; ; FileWrite $0 "LANDMARKS_FILENAME = $INSTDIR\resources\landmarks.adeona$\n"
;  FileWrite $0 "MAX_SLEEPTIME = 300$\n"
; ;FileWrite $0 "GATEWAYS_FILENAME = $INSTDIR\resources\gateways.adeona$\n"
;  FileWrite $0 "USE_WEBCAMIMG = 0$\n"   ; set USE_WEBCAMING to be zero, since this fails in Windows always, yes?
;  FileWrite $0 "GWUPDATE_URL = adeona.cs.washington.edu/gateways.adeona$\n"
;  FileWrite $0 "USE_GWUPDATE = 1$\n"
; ; FileWrite $0 "WEBCAMPROG_PATH = $INSTDIR\resources\isightcapture.exe$\n"
;  FileClose $0

; Creat Start Menu entry
  SetOverwrite ifnewer
  CreateDirectory "$SMPROGRAMS\Adeona"
  CreateShortCut "$SMPROGRAMS\Adeona\Uninstall Adeona.lnk" "$INSTDIR\Uninstall.exe"
SectionEnd

Section "Adeona Client" SEC01
  StrCpy $clientflag "true"
  
  SetOutPath "$INSTDIR"
  SetOverwrite ifnewer
  File "..\..\adeona-client.exe"
  File "..\..\adeona-init.exe"
  File "packagefiles\InitAdeona.bat"
  File "packagefiles\StartAdeona.bat"
  File "packagefiles\StopAdeona.bat"

 
SectionEnd



Section "Adeona Recovery Tools" SEC02
  CreateDirectory "$INSTDIR\resources"
  CreateDirectory "$INSTDIR\logs"
  SetOutPath "$INSTDIR\resources"
  SetOverwrite ifnewer
;  File "packagefiles\resources\options.adeona"
  File "..\..\resources\gateways.adeona"

  SetOutPath "$INSTDIR"
  File "packagefiles\adeona-retrieve.bat"
  File "packagefiles\AdeonaRecovery.exe"
  File "..\..\adeona-retrieve.exe"

  SetOverwrite ifnewer
  CreateDirectory "$SMPROGRAMS\Adeona"
  CreateShortCut "$SMPROGRAMS\Adeona\Run Adeona Recovery.lnk" "$INSTDIR\AdeonaRecovery.exe"
SectionEnd

LangString DESC_Section1 ${LANG_ENGLISH} "The Adeona Client periodically sends private updates \
           regarding the current location of your laptop to a remote storage facility on the Internet."
LangString DESC_Section2 ${LANG_ENGLISH} "The Adeona Recovery tools help one retrieve updates sent \
            by a laptop. $\n$\nThis is all that is required to perform retrieval of updates sent from a machine."

!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC01} $(DESC_Section1)
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC02} $(DESC_Section2)
!insertmacro MUI_FUNCTION_DESCRIPTION_END

Section -Post
  WriteUninstaller "$INSTDIR\Uninstall.exe"
SectionEnd


Function myComponentLeave
   SectionGetFlags ${SEC01} $0
   IntOp $1 $0 & ${SF_SELECTED}
   SectionGetFlags ${SEC02} $2
   IntOp $3 $2 & ${SF_SELECTED}
   IntOp $4 $1 | $3
   ${If} $4 == 0
         MessageBox MB_OK "Please select at least one component." IDOK true3
         true3:
              Abort ; forces to stay on this page
         Abort
   ${EndIf}
FunctionEnd


Function passwordPage

  !insertmacro MUI_HEADER_TEXT "Initializing the Adeona client" "Choose a password"

   SectionGetFlags ${SEC01} $0

   IntOp $1 $0 & ${SF_SELECTED}
   ${If} $1 == 0
         Abort
   ${EndIf}
   
   nsDialogs::Create /NOUNLOAD 1018
   Pop $Dialog

   ${If} $Dialog == error
      Abort
   ${EndIf}

   ${NSD_CreateLabel} 0 0 100% 26u "To protect your location finding credentials, please pick a password for Adeona. \
                                  It does not need to be the same as your login password."
   Pop $Label

   ${NSD_CreateLabel} 0 30u 40% 24u "Adeona password:"
   
   ${NSD_CreatePassword} 45% 30u 50% 12u ""
   Pop $passwordbox

   ${NSD_SetFocus} $passwordbox

   ${NSD_CreateLabel} 0 50u 40% 24u "Please re-enter your Adeona password for verification:"

   ${NSD_CreatePassword} 45% 53u 50% 12u ""
   Pop $passwordboxver


   nsDialogs::Show
FunctionEnd

Function passwordPageEnd
   ${NSD_GetText} $passwordbox $password
   ${NSD_GetText} $passwordboxver $passwordver
   ${If} $password == ""
         MessageBox MB_OK "Password is empty. To ensure privacy of your device tracking updates, please specify a password." IDOK true2
         true2:
              Abort ; forces to stay on this page
   ${EndIf}
   ${If} $password != $passwordver
         MessageBox MB_OK "Passwords do not match. Please try again." IDOK true
         true:
              Abort ; forces to stay on this page
   ${EndIf}
   
   
   
   ExecWait '"$INSTDIR\InitAdeona.bat" "$INSTDIR" "$password"'

   CopyFiles "$INSTDIR\adeona-retrievecredentials.ost" "$DESKTOP\"
FunctionEnd


Function FinishPage
   nsDialogs::Create /NOUNLOAD 1018
   Pop $0

   ${If} $0 == error
      Abort
   ${EndIf}


   SectionGetFlags ${SEC01} $0
   
   IntOp $1 $0 & ${SF_SELECTED}
   ${If} $1 != 0
        !insertmacro MUI_HEADER_TEXT "Setup complete" "Remember to backup your owner credentials."
      ${NSD_CreateLabel} 0 0 100% 100% "IMPORTANT: Please don't forget to make a backup copy of your location-finding credentials,$\r$\n$\r$\n\
                                   $\t adeona-retrievecredentials.ost$\r$\n$\r$\n\
                                    A copy has been created on your Desktop. You can simply e-mail it to yourself, put it in a USB Memory Stick or, \
                                    even write down the contents on a piece of paper since the contents have been protected by the password you gave \
                                    during the installation process.$\r$\n$\r$\n$\r$\n\
                                    NOTE: Adeona has pseudorandomly scheduled updates and there may not be any location information stored in OpenDHT \
                                    yet. Please wait about 1 hour before trying to do a retrieval.$\r$\n$\r$\n\
                                    For questions, comments and suggestions,please visit our website at http://adeona.cs.washington.edu/contact.html $\r$\n$\r$\n\
                                    Thank you for using Adeona!"
      Pop $1
   ${Else}
           !insertmacro MUI_HEADER_TEXT "Installation complete" ""
     ${NSD_CreateLabel} 0 0 100% 100% "Installation is complete. You can now use the Adeona Recovery tools."
      Pop $1
   ${EndIf}
   nsDialogs::Show
FunctionEnd


;Function .onInstSuccess
  ;  MessageBox MB_OK "Installation successful. Click OK to read important instructions regarding recovery."
   ;   Exec '"notepad.exe Conclusion.txt' ; view readme or whatever, if you want.
;FunctionEnd

Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "Adeona was successfully removed from your computer."
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove Adeona and all of its components?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  SetOutPath "$INSTDIR"  ; Something very strange with working directory for StopAdeona.bat
  ExecWait '"$INSTDIR\StopAdeona.bat"'
  SetOutPath "$PROGRAMFILES" 
  
  Delete "$INSTDIR\resources\*"
  RMDir "$INSTDIR\resources"
  Delete "$INSTDIR\logs\*"
  RMDir "$INSTDIR\logs"
  Delete "$INSTDIR\*"
   
  RMDir "$INSTDIR"
  Delete "$SMPROGRAMS\Adeona\Run Adeona Recovery.lnk"
  Delete "$SMPROGRAMS\Adeona\Uninstall Adeona.lnk"
  RMDir "$SMPROGRAMS\Adeona"
  
  SetAutoClose true
SectionEnd
